package it.unisannio.ding.ids.wedroid.app.util

import it.unisannio.ding.ids.wedroid.wrapper.api.*
import okhttp3.OkHttpClient
import retrofit2.Retrofit
import retrofit2.converter.gson.GsonConverterFactory

object ServicesFactory {
    private val retrofit: Retrofit
    private lateinit var reader: PreferenceReader //TODO

    init {
        val httpClient = OkHttpClient.Builder()
            .addInterceptor {
                val request = it.request().newBuilder()
                    .addHeader("Authorization", "Bearer ${reader.token}")
                    .addHeader("Accept", "application/json")
                    .addHeader("Content-type", "application/json")
                    .build()

                it.proceed(request)
            }.build()

        retrofit = Retrofit.Builder()
            .baseUrl(reader.baseUrl)
            .addConverterFactory(GsonConverterFactory.create())
            .client(httpClient)
            .build()
    }

    val boardService by lazy {
        retrofit.create(BoardService::class.java)
    }

    val cardCommentService by lazy {
        retrofit.create(CardCommentService::class.java)
    }

    val cardService by lazy {
        retrofit.create(CardService::class.java)
    }

    val checklistService by lazy {
        retrofit.create(ChecklistService::class.java)
    }

    val listService by lazy {
        retrofit.create(ListService::class.java)
    }

    val swimlanesService by lazy {
        retrofit.create(SwimlanesService::class.java)
    }

    val userService by lazy {
        retrofit.create(UserService::class.java)
    }
}

